### Name: externalFormats
### Title: Read and write external matrix formats
### Aliases: readHB readMM writeHB writeMM writeHB,dgCMatrix-method
###   writeHB,dgTMatrix-method writeHB,dsCMatrix-method
###   writeHB,dsTMatrix-method writeMM,dgCMatrix-method
###   writeMM,dgTMatrix-method writeMM,dsCMatrix-method
###   writeMM,dsTMatrix-method
### Keywords: IO array algebra

### ** Examples

str(pores <- readMM(system.file("external/pores_1.mtx",
                                package = "Matrix")))
str(utm <- readHB(system.file("external/utm300.rua",
                               package = "Matrix")))
str(lundA <- readMM(system.file("external/lund_a.mtx",
                                package = "Matrix")))
str(lundA <- readHB(system.file("external/lund_a.rsa",
                                package = "Matrix")))
## Not run: 
##D ## NOTE: The following examples take quite some time
##D ## ----  even on a fast internet connection:
##D str(sm <-
##D  readHB(gzcon(url("http://www.cise.ufl.edu/research/sparse/HBformat/Boeing/msc00726.rsa.gz"))))
##D str(jgl009 <-
##D  readMM(gzcon(url("ftp://math.nist.gov/pub/MatrixMarket2/Harwell-Boeing/counterx/jgl009.mtx.gz"))))
## End(Not run)
data(KNex)
## Not run: 
##D writeHB(KNex$mm, "mmHB.rua")
## End(Not run)
writeMM(KNex$mm, "mmMM.mtx")



