### Name: lsparseMatrix-classes
### Title: Sparse logical matrices
### Aliases: lsparseMatrix-class lgCMatrix-class ltCMatrix-class
###   lsCMatrix-class lgRMatrix-class ltRMatrix-class lsRMatrix-class
###   lgTMatrix-class ltTMatrix-class lsTMatrix-class
###   -,lsparseMatrix,missing-method !,lsparseMatrix-method
###   \%*\%,lgCMatrix,lgCMatrix-method
###   \%*\%,lsparseMatrix,lsparseMatrix-method
###   \%*\%,lsparseMatrix,ldenseMatrix-method
###   \%*\%,ldenseMatrix,lsparseMatrix-method chol,lsCMatrix,logical-method
###   chol,lsCMatrix,missing-method coerce,lgCMatrix,dgCMatrix-method
###   coerce,lgCMatrix,lgTMatrix-method coerce,lgCMatrix,lsCMatrix-method
###   coerce,lgCMatrix,lgeMatrix-method coerce,lgCMatrix,matrix-method
###   coerce,lgTMatrix,dgTMatrix-method coerce,lgTMatrix,lgCMatrix-method
###   coerce,lgTMatrix,lsCMatrix-method coerce,lgTMatrix,matrix-method
###   coerce,lsCMatrix,dgTMatrix-method coerce,lsCMatrix,dsCMatrix-method
###   coerce,lsCMatrix,lgCMatrix-method coerce,lsCMatrix,lgTMatrix-method
###   coerce,lsCMatrix,lsTMatrix-method coerce,lsCMatrix,matrix-method
###   coerce,lsTMatrix,dsTMatrix-method coerce,lsTMatrix,lgTMatrix-method
###   coerce,lsTMatrix,lsCMatrix-method coerce,lsTMatrix,matrix-method
###   coerce,ltCMatrix,dtCMatrix-method coerce,ltCMatrix,dMatrix-method
###   coerce,ltCMatrix,lgCMatrix-method coerce,ltCMatrix,matrix-method
###   coerce,matrix,lgCMatrix-method coerce,matrix,lsCMatrix-method
###   coerce,matrix,lgTMatrix-method coerce,matrix,ltCMatrix-method
###   coerce,lsparseMatrix,matrix-method coerce,ltTMatrix,dtTMatrix-method
###   coerce,ltTMatrix,lgTMatrix-method coerce,ltTMatrix,matrix-method
###   crossprod,lgCMatrix,missing-method crossprod,lgTMatrix,missing-method
###   crossprod,lsparseMatrix-method crossprod,lsparseMatrix,missing-method
###   crossprod,lsparseMatrix,lsparseMatrix-method
###   crossprod,lsparseMatrix,ldenseMatrix-method
###   crossprod,ldenseMatrix,lsparseMatrix-method diag,lgCMatrix-method
###   diag,lsparseMatrix-method image,lgCMatrix-method
###   image,lsCMatrix-method image,lsTMatrix-method image,ltCMatrix-method
###   image,ltTMatrix-method t,lgCMatrix-method t,lgTMatrix-method
###   t,lsCMatrix-method t,ltCMatrix-method
###   tcrossprod,lgCMatrix,missing-method
###   tcrossprod,lgTMatrix,missing-method
###   tcrossprod,lsparseMatrix,missing-method
### Keywords: classes algebra

### ** Examples

str(m <- Matrix(c(0,0,2:0), 3,5, dimnames=list(LETTERS[1:3],NULL)))
(lm <- (m > 1)) # lgC
stopifnot(is(lm,"lsparseMatrix"))
!lm     # no longer sparse

data(KNex)
str(mmG.1 <- (KNex $ mm) > 0.1)# "lgC..."
## from logical to nz_pattern -- okay when there are no NA's :
nmG.1 <- as(mmG.1, "nMatrix")
## from logical to "double"
dmG.1 <- as(mmG.1, "dMatrix") # and back:
lmG.1 <- as(dmG.1, "lMatrix")
stopifnot(validObject(lmG.1), identical(lmG.1, mmG.1))

class(xnx <- crossprod(nmG.1))# "nsC.."
class(xlx <- crossprod(mmG.1))# "dsC.." : numeric
table(xlx@x != 0)# almost have are (non-structural!) 0
stopifnot(isSymmetric(xlx), isSymmetric(xnx),
          ## compare xnx and xlx :
          sapply(slotNames(xnx),
                 function(n) identical(slot(xnx, n), slot(xlx, n))))



